(function ($, Drupal, once) {
  Drupal.behaviors.voiceSearch = {
    attach: function (context, settings) {

      if ('webkitSpeechRecognition' in window) {
        const recognition = new webkitSpeechRecognition();
        recognition.lang = 'en-US';
        recognition.continuous = false;
        recognition.interimResults = false;

        // Select the voice search button
        $(once('voiceSearch', 'input[data-drupal-selector="edit-voice-search-button"]', context)).on('click', function(event) {
          // Prevent the form from submitting immediately.
          event.preventDefault();
          // Start speech recognition.
          recognition.start();
        });

        // Handle the speech recognition result.
        recognition.onresult = function(event) {
          const searchQuery = event.results[0][0].transcript;
          // Fill the search input with recognized text.
          document.getElementById('edit-keys').value = searchQuery;
          // Submit the form after speech is recognized
          document.getElementById('search-block-form').submit();
        };
      }
    }
  };
})(jQuery, Drupal, once);
